/* The fsl modules is just a wrapper to hold the multiply, overlap and output blocks
   its only repsonsibilty is to pass the data correctly into the sub parts of this 
   expression
*/
module fsl_overlap(clk,rst, FSL_top_exists, FSL_bottom_exists, FSL_top_data, FSL_bottom_data,
				FSL_top_read, FSL_bottom_read, FSL_top_cntrl, FSL_bottom_cntrl,
				FSL_full, FSL_data, FSL_cntrl, FSL_write);
	parameter READ_O_A	= 2'b10,
			READ_O_B 	= 2'b11,
			READ_AB 	= 2'b01,
			DROP		= 2'b00;

  	//takes all the signals from the outerwrapper
	//most of are FSL controls and can be read about in the appropriate documentation
	input clk, rst, FSL_top_exists, FSL_bottom_exists, FSL_top_cntrl, FSL_bottom_cntrl;
	input FSL_full;
	input [15:0] FSL_top_data, FSL_bottom_data;
	
	output FSL_top_read, FSL_bottom_read, FSL_write, FSL_cntrl;
	output [15:0] FSL_data;

	wire [1:0]mode;							//what mode we are using for data
	wire rdy, rdy_out, mult_rdy_out, mult_rdy_in;
	wire [15:0] dataA, dataB;
	wire [15:0] result;
	wire [13:0] stage;
	wire [2:0]  size;

	wire [15:0] data_out, data_b1, data_b2;
	wire BtoA;

	assign data_b1 = (mode[0]) ? dataB : dataA;
	assign data_b2 = (mode[0]) ? result : 15'b1001110001110001;
	assign data_out = (mode[1]) ? data_b1:  data_b2;

	assign rdy_out = (mode == READ_AB ? mult_rdy_out : rdy);
	assign mult_rdy_in = (rdy && (mode == READ_AB));

	overlap o1(clk, rst, FSL_top_exists, FSL_bottom_exists, FSL_top_data, FSL_bottom_data,
				FSL_top_read, FSL_bottom_read, dataA, dataB, stage, size, mode, BtoA, rdy, done);

	mem_wrapper m1(clk, rst, dataA, dataB, stage, size, result, ~BtoA, mult_rdy_in, mult_rdy_out);

	output_link ol1(clk, rst, data_out, FSL_full, FSL_data, FSL_cntrl, FSL_write, rdy_out, done);	


endmodule
