library verilog;
use verilog.vl_types.all;
entity overlap is
    generic(
        reset           : integer := 0;
        size_r          : integer := 1;
        get_r           : integer := 2;
        wait_spec       : integer := 3;
        read_spec       : integer := 4;
        done_spec       : integer := 5;
        size_b          : integer := 6;
        get_b           : integer := 7;
        wait_b          : integer := 8;
        read_b          : integer := 9;
        done_b          : integer := 10;
        flip_c          : integer := 11;
        pause_i_w       : integer := 12;
        pause_i_r       : integer := 13;
        pause_o_w       : integer := 14;
        pause_o_r       : integer := 15;
        read_o_a        : integer := 2;
        read_o_b        : integer := 3;
        read_ab         : integer := 1;
        drop            : integer := 0
    );
    port(
        clk             : in     vl_logic;
        rst             : in     vl_logic;
        fsl_top_exists  : in     vl_logic;
        fsl_bottom_exists: in     vl_logic;
        fsl_top_data    : in     vl_logic_vector(15 downto 0);
        fsl_bottom_data : in     vl_logic_vector(15 downto 0);
        fsl_top_read    : out    vl_logic;
        fsl_bottom_read : out    vl_logic;
        dataa           : out    vl_logic_vector(15 downto 0);
        datab           : out    vl_logic_vector(15 downto 0);
        stage           : out    vl_logic_vector(13 downto 0);
        size            : out    vl_logic_vector(2 downto 0);
        mode            : out    vl_logic_vector(1 downto 0);
        cur_channel     : out    vl_logic;
        rdy             : out    vl_logic;
        done            : in     vl_logic
    );
end overlap;
