#include "AC97Player.h"

extern "C" {
#include "xparameters.h"
#include "xutil.h"
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "xac97.h" 
#include "xac97_l.h"
#include "xac97_i.h"
#include "mb_interface.h"
};

#include <stdio.h>
#include "helpers.h"

AC97Player::AC97Player()
{
}

AC97Player::~AC97Player()
{
	playback_disable();
}

int
AC97Player::init(id_header_t &header)
{
	init_sound(header.sample_rate);
	playback_enable();
}

#define mb_bwrite_datafsl(val, id)      \
	asm volatile ("put %0, rfsl" #id : : "d" (##val##))
	
int
AC97Player::play(INT16 **data, int size)
{
	INT16* left = data[0];
	INT16* right = data[1];
	for(int i = 0; i < size; i++,right++,left++) {
		mb_bwrite_datafsl(*left, 1);
		mb_bwrite_datafsl(*right, 1);
//		microblaze_bwrite_datafsl(*left, 0);
//		microblaze_bwrite_datafsl(*right, 0);
	}
	return 0;
}
