#ifndef FLOOR1_H
#define FLOOR1_H

// Sizes "borrowed" from xiph libvorbis library
#define VIF_POSIT 63
#define VIF_CLASS 16
#define VIF_PARTS 31
typedef struct _floor_config {
	INT16		classes[VIF_PARTS];
	UINT8		subclasses[VIF_CLASS];
	UINT8		dimensions[VIF_CLASS];
	UINT8		masterbooks[VIF_CLASS];
	INT16		subclass_books[VIF_CLASS][8];
	UINT8		num_partitions;
	UINT8		multiplier;
	INT16		max_class;
	UINT32		x_list[VIF_POSIT+2];
	UINT32		low_neig[VIF_POSIT+2];
	UINT32		high_neig[VIF_POSIT+2];
	UINT32		sorted_index[VIF_POSIT+2];
	UINT8		range_bits;
	UINT32		num_positions;
} floor_config_t;


#define FLOOR_OKAY	0
#define FLOOR_ERROR	-1
#define FLOOR_UNUSED	1

extern int parse_floors(OggStream &ogg);
extern int decode_floor1_packet(OggStream &ogg, floor_config_t &floor,
		INT32 *floor_Y);
extern void floor1_synthesis(FIXINT32 *pcm, UINT32 n, INT32 *floor_Y,
				floor_config_t &floor);

#endif
