#ifndef RESIDUE_H
#define RESIDUE_H

/* Data types */

#define RESIDUE_BOOK_UNUSED	-1

typedef struct _residue_config {
	UINT32	begin;
	UINT32	end;
	UINT32	partition_size;
	UINT16	type;
	UINT8	classifications;
	UINT8	classbook;
	UINT8	cascade[64];
	INT16	books[64][8];
	UINT32	partvals;
	UINT32	stages;
	UINT32	**decodemap;
} residue_t;

/* Function declarations */

extern int prepare_residue(residue_t &residue);
extern void clean_residue(residue_t &residue);
extern int decode_residue(OggStream &ogg, int ch, UINT32 n, 
				residue_t &residue, FIXINT32** data,
				Bitset &do_not_decode);

#endif // ! RESIDUE_H
