#ifndef VORBIS_DEFS_H
#define VORBIS_DEFS_H

#include <math.h>

/*
 * Some useful definitions
 */

typedef struct _submap_config {
	UINT8		floor;
	UINT8		residue;
} submap_t;

typedef struct _mapping_config {
	UINT16		coupling_steps;
	UINT8		magnitude[256];
	UINT8		angle[256];
	UINT8		mux[256];
	submap_t	submap[256];
	UINT8		num_submaps;
} mapping_t;

typedef struct _mode_config {
	UINT16	mapping;
	UINT8	blockflag;
} mode_config_t;


/*
 * Global variables
 */
extern id_header_t	id_header;
extern UINT16		codebook_count;
extern UINT8		floor_count;
extern UINT8		residue_count;
extern UINT8		mapping_count;
extern UINT8		mode_count;
extern codebook_t	codebooks[256];
extern floor_config_t	floor_config[64];
extern residue_t	residue[64];
extern mapping_t	mappings[64];
extern mode_config_t	modes[64];

/*
 * Function declarations
 */
extern int decode_audio_packet(OggStream &ogg, FIXINT32 **pcm, 
				int &c_bits, int &n_bits);
extern int validate_vorbis_header(OggStream &ogg);

#endif
