/*
 *  * Copyright (c) 2004 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 6.3 EDK_Gmm.10
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    D:\hardware\base_system
 */

typedef unsigned int UINT;
// Located in: microblaze_0/include/xparameters.h
#include "xparameters.h"

#include "xutil.h"
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "xac97.h"
#include "xac97_l.h"
#include "xac97_i.h"
#include "mb_interface.h"
//====================================================

int main (void) {
	int i;
	short *input, *output;
	Xuint16 soundbyte[1000];
    print("-- Entering main() --\r\n");


   /* 
    * MemoryTest routine will not be run for the memory at 
    * dlmb_cntlr.C_BASEADDR
    * because it is being used to hold a part of this application program
    */

#if 0
	printf("----Starting up sound card --\r\n");
	init_sound(22000);
	printf("----Ending sound--------------\r\n");
   /* 
    * MemoryTest routine will not be run for the memory at 
    * ilmb_cntlr.C_BASEADDR
    * because it is being used to hold a part of this application program
    */

	playback_enable();
 	record_enable();
 	record_fifo_clear(); 
#endif
   /* 
    * MemoryTest routine will not be run for the memory at 
    * dlmb_cntlr.C_BASEADDR
    * because it is being used to hold a part of this application program
    */
	xil_printf("Testing Overlapper Block\n\r");
	input = (short*)XPAR_OPB_EMC_0_MEM0_BASEADDR;
	for(i = 0; i < 2; i++) {
		int j;
		int temp = (int)*input;
		int N = 1 << (((*input++ & 0x38) >> 3) + 6);
		xil_printf("Block %d has %d samples.\n\r",i,N);
		microblaze_bwrite_datafsl(temp, 0);
		for(j = 0; j < N; j++) {
			int k = 0;
			temp = (int)*(input++);
			//if ((j % 1) == 0) {
			xil_printf("Writing sample %d to fsl (input = 0x%08x).\n\r", j, (unsigned)input);
			//}
			// Write out one sample for each channel
			for(;k<1000;k++);
			xil_printf("Trying to write.\n\r");
			microblaze_bwrite_datafsl(temp, 0);
			temp = (int)*(input++);
			for(;k<1000;k++);
			xil_printf("Trying to write.\n\r");
			microblaze_bwrite_datafsl(temp, 0);
//			if (j > 10) {
//				xil_printf("Trying to read.\n");
//				microblaze_bread_datafsl(temp, 0);
//				xil_printf("Read 0x%08x from overlapper.\n\r", temp); 
//			}
		}
	}
//while(1);
	xil_printf("Reading 256 'zeroes'\n\r");
	for(i = 0; i < 256; i++,output++) {
		int result;
		xil_printf("Trying to read.\n\r");
		microblaze_bread_datafsl(result, 0);
		result >>= 4;
		if (result != 7281) {
			xil_printf("Read 0x%080x NOT 0x%08x\n\r", result, 7281);
		}
	}

	xil_printf("Comparing 512 bytes of output\n");
	output = (short*)XPAR_OPB_EMC_0_MEM1_BASEADDR;
	for(i = 0; i < 256; i++,output++) {
		int t;
		xil_printf("Trying to read.\n\r");
		microblaze_bread_datafsl(t, 0);
		if ((t>>4) != *output) {
			xil_printf("%d: 0x%08x != 0x%08x\n\r", i, (t>>4), *output);
		}
	}
	xil_printf("Writing 3rd packet to FSL\n\r");
	for(i = 2; i < 3; i++) {
		int j;
		int temp = (int)*input;
		int N = 1 << (((temp & 0x38) >> 3) + 6);
		xil_printf("Block %d has %d samples.\n\r",i,N);
		microblaze_bwrite_datafsl(temp, 0);
		for(j = 0; j <= N; j++) {
			int t = (int)*(input++);
			//if ((j % 1) == 0) {
			xil_printf("Writing sample %d to fsl.\n\r", j);
			//}
			// Write out one sample for each channel
			microblaze_bwrite_datafsl(t, 0);
			t = (int)*(input++);
			microblaze_bwrite_datafsl(t, 0);
		}
	}
	xil_printf("Comparing 2304 bytes of output\n");
	for(i = 0; i < 1152; i++,output++) {
		int t;
		microblaze_bread_datafsl(t, 0);
		if (t != (int)*output) {
			xil_printf("%d: 0x%08x != 0x%08x\n\r", i, t, *output);
		}
	}
while(1);
			

#if 0
	xil_printf("Playing stored output\n\r");
	mem = (short*)XPAR_OPB_EMC_0_MEM1_BASEADDR;
	while(mem < (short*)(XPAR_OPB_EMC_0_MEM1_BASEADDR+2418))
	{
		int t = *mem << 4;
		microblaze_bwrite_datafsl(t, 1);
		mem++;
	}

	record_fifo_clear();
#endif

   print("-- Exiting main() --\r\n");
   while(1);
   return 0;
}

