/*
 *  * Copyright (c) 2004 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 6.3 EDK_Gmm.10
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    D:\hardware\base_system
 */

typedef unsigned int UINT;
// Located in: microblaze_0/include/xparameters.h
#include "xparameters.h"

#include "xutil.h"
#include "xbasic_types.h"   /* Xilinx basic types for device drivers        */
#include "xac97.h"
#include "xac97_l.h"
#include "xac97_i.h"
#include "mb_interface.h"
//====================================================

int main (void) {
	int i;
	UINT *mem;
	Xuint16 soundbyte[1000];
    print("-- Entering main() --\r\n");

	xil_printf("Testing xil_printf.\n\r");
	for (i = 0; 0 == 0; i++) {
		unsigned j;
		xil_printf("Loop counter is %d\n\r", i);
		for(j = 0; j < 0xffff; j++);
	}

   /* 
    * MemoryTest routine will not be run for the memory at 
    * dlmb_cntlr.C_BASEADDR
    * because it is being used to hold a part of this application program
    */

	printf("----Starting up sound card --\r\n");
	init_sound(22000);
	printf("----Ending sound--------------\r\n");
   /* 
    * MemoryTest routine will not be run for the memory at 
    * ilmb_cntlr.C_BASEADDR
    * because it is being used to hold a part of this application program
    */

	playback_enable();
 	record_enable();
 
 	record_fifo_clear(); 

   /* 
    * MemoryTest routine will not be run for the memory at 
    * dlmb_cntlr.C_BASEADDR
    * because it is being used to hold a part of this application program
    */
/*
	mem = (UINT*)XPAR_OPB_EMC_0_MEM0_BASEADDR;

	print("Writing full mem test\r\n");
	while (mem <= (UINT*)XPAR_OPB_EMC_0_MEM4_HIGHADDR){
		//*mem = ((UINT) mem);
		*mem = 0x80C01234;
		mem++;
	}

	print("doing full memory read\r\n");
	mem = (UINT*)XPAR_OPB_EMC_0_MEM0_BASEADDR;
	while (mem <= (UINT*)XPAR_OPB_EMC_0_MEM4_HIGHADDR){
		if (*mem != 0x80c01234){
		//if (*mem != ((UINT) mem)){
			printf("Error at 0x%x \n\r", mem);
			printf("       = 0x%x  \r\n", *mem);
		}
		mem += 2048;
	}
 */
 	printf("begin seaking \r\n");
   	//while(1){
		mem = (UINT*)XPAR_OPB_EMC_0_MEM0_BASEADDR;
	 	while(mem < (UINT*)XPAR_OPB_EMC_0_MEM0_HIGHADDR)
		{
			*mem = opb_read_recordfifo();
			mem++;
	 	}

		printf("end speaking \r\n");

		mem = (UINT*)XPAR_OPB_EMC_0_MEM0_BASEADDR;
	 	while(mem < (UINT*)XPAR_OPB_EMC_0_MEM0_HIGHADDR)
		{
			microblaze_bwrite_datafsl(*mem, 1);
			mem++;
		}

	record_fifo_clear();

   print("-- Exiting main() --\r\n");
   return 0;
}

