-- clk_align.vhd file
-- Note: This circuit assumes that all buses and DCMs are reset active low.
----------------------------------------------------------------------------
library IEEE;
use IEEE.STD_Logic_1164.all; 
use IEEE.STD_Logic_arith.all;
use IEEE.STD_Logic_unsigned.all;


entity clk_align is
  port(	external_clk:		in	STD_LOGIC;
	extend_dcm_reset:	in	STD_LOGIC;
	dcm0_locked:		in	STD_LOGIC;
	dcm1_locked:		in	STD_LOGIC;
	fpga_reset:		out	STD_LOGIC;
	dcm_reset:		out	STD_LOGIC);
end entity clk_align;

architecture behaviour of clk_align is
  signal dcm_reset_counter:	STD_LOGIC_VECTOR(0 to 15) := X"0000";
  signal terminal_count:	STD_LOGIC;
  signal enable_reset_counter:	STD_LOGIC;


begin

dcm_reset            <= dcm_reset_counter(0);
fpga_reset           <= dcm0_locked and dcm1_locked ;
--(for N dcms: fpga_reset<=dcm0_locked and dcm1_locked and ... and dcmN_locked);

enable_reset_counter <= not terminal_count AND extend_dcm_reset;

dcm_reset_counter_inst : process (external_clk)
begin
  if(external_clk='1' and external_clk'event) then
          if(enable_reset_counter = '1') then
                  dcm_reset_counter <=  dcm_reset_counter + 1;
	    else
			dcm_reset_counter <= '0';
          end if;
        end if;
end process;

Decode_term_count : process (dcm_reset_counter)
begin
        if(dcm_reset_counter = "1111111111111111") then
            terminal_count <= '1';
        else
             terminal_count <= '0';
        end if;
end process;

end architecture behaviour;