`timescale 10ns/1ns

module outer_wrapper_full_test_v_tf();

// DATE:     10:27:29 03/17/2005 
// MODULE:   outer_wrapper
// DESIGN:   outer_wrapper
// FILENAME: full_test.v
// PROJECT:  overlapp
// VERSION:  


// Inputs
    reg clk;
    reg rst;
    reg [15:0] FSL_in_data;
    reg FSL_in_exists;
    reg FSL_in_cntrl;
    reg FSL_out_full;
    reg [15:0] i;


// Outputs
    wire FSL_in_read;
    wire [15:0] FSL_out_data;
    wire FSL_out_write;
    wire FSL_out_cntrl;
    wire rdy_out;
    wire done;


// Bidirs


// Instantiate the UUT
    outer_wrapper uut (
        .clk(clk), 
        .rst(rst), 
        .FSL_in_data(FSL_in_data), 
        .FSL_in_exists(FSL_in_exists), 
        .FSL_in_read(FSL_in_read), 
        .FSL_in_cntrl(FSL_in_cntrl), 
        .FSL_out_data(FSL_out_data), 
        .FSL_out_full(FSL_out_full), 
        .FSL_out_write(FSL_out_write), 
        .FSL_out_cntrl(FSL_out_cntrl)
        );


always #5 clk = ~clk;

task put_data_packet;
	output [15:0] FSL_data;
	output FSL_exists;
	input  [2:0] next, packet_size, prev;
	input  size_real;
	begin
		#10;
		FSL_data = {next, packet_size, prev};
		#10;
		FSL_exists = 1'b1;
	end
endtask

always @(posedge clk) 	 if (FSL_in_exists == 1 && FSL_in_read == 1) FSL_in_exists = 0;
					 else FSL_in_exists = FSL_in_exists;

initial begin
     clk = 0;
     rst = 1;
     FSL_in_data = 0;
     FSL_in_exists = 0;
     FSL_in_cntrl = 0;
	FSL_out_full = 0;

	#50;
	rst = 0;

	#10;
	put_data_packet (FSL_in_data, FSL_in_exists, 3'b001, 3'b001, 3'b001, 128);

	#20;
	for (i = 0; i < 128; i = i + 1)
	begin
		#15;
		FSL_in_data = i;
		#5;
		FSL_in_exists = 1'b1;
	end		

	#10;
	put_data_packet (FSL_in_data, FSL_in_exists, 3'b001, 3'b001, 3'b001, 128);

	#20;
	for (i = 0; i < 128; i = i + 1)
	begin
		#15;
		FSL_in_data = i << 2;
		#5;
		FSL_in_exists = 1'b1;
	end		
	  
	#10;
	put_data_packet (FSL_in_data, FSL_in_exists, 3'b111, 3'b001, 3'b001, 128);

	#40;
	for (i = 0; i < 128; i = i + 1)
	begin	    
		#15;
		FSL_in_data = i << 4;
		#5;
		FSL_in_exists = 1'b1;
	end		
end

endmodule

