module mem_wrapper(clk, rst, data_top, data_btm, stage, size, result, BtoA, rdy, done);
	input clk, rst, rdy;
	input [15:0] data_top, data_btm;
	input [13:0] stage;
	input [2:0] size;
	input BtoA;

	output [15:0] result;
	output done;

	wire [15:0] result_top, result_btm;
	wire done_top, done_btm;
	wire [15:0] memory_top, memory_btm;
	wire [12:0] address_top, address_btm;
	wire [13:0] stage_top;
	wire [13:0] stage_btm;
	wire [2:0] size;
	wire BtoA;

	assign stage_top = BtoA ? (1 << (5+size)) - stage : stage - 1;
	assign stage_btm = BtoA ? stage  -  1: (1 << (5+size)) - stage;
	
	//TODO FIX STAGE TO OPPOSITE
	mult_unit m1(clk, rst, data_top, stage_top, size, 
			memory_top, address_top, result_top, rdy, done_top);

	mult_unit m2(clk, rst, data_btm, stage_btm, size, 
			memory_btm, address_btm, result_btm, rdy, done_btm);


	look_tblt tbl(
    		.addra(address_top),
    		.addrb(address_btm),
    		.clka(clk),	
    		.clkb(clk),
    		.douta(memory_top),
    		.doutb(memory_btm));	


	assign done = done_top && done_btm;
	assign result = result_top + result_btm; 
endmodule
