

`timescale 10ns/1ns

module fsl_overlap_overlap_test_v_tf();

// DATE:     00:22:47 03/17/2005 
// MODULE:   fsl_overlap
// DESIGN:   fsl_overlap
// FILENAME: overlap_test.v
// PROJECT:  overlapp
// VERSION:  


// Inputs
    reg clk;
    reg rst;
    reg FSL_top_exists;
    reg FSL_bottom_exists;
    reg [15:0] FSL_top_data;
    reg [15:0] FSL_bottom_data;
    reg FSL_top_cntrl;
    reg FSL_bottom_cntrl;
    reg FSL_full;    
    reg [10:0] i, i2;


// Outputs
    wire FSL_top_read;
    wire FSL_bottom_read;
    wire [15:0] FSL_data;
    wire FSL_cntrl;
    wire FSL_write;
    wire rdy_out,done;
    wire [15:0]dataA, dataB, result, data_out;
    wire [1:0]mode;
    wire [13:0] stage;
	wire [2:0]  size;

// Bidirs


// Instantiate the UUT
    fsl_overlap uut (
        .clk(clk), 
        .rst(rst), 
        .FSL_top_exists(FSL_top_exists), 
        .FSL_bottom_exists(FSL_bottom_exists), 
        .FSL_top_data(FSL_top_data), 
        .FSL_bottom_data(FSL_bottom_data), 
        .FSL_top_read(FSL_top_read), 
        .FSL_bottom_read(FSL_bottom_read), 
        .FSL_top_cntrl(FSL_top_cntrl), 
        .FSL_bottom_cntrl(FSL_bottom_cntrl), 
        .FSL_full(FSL_full), 
        .FSL_data(FSL_data), 
        .FSL_cntrl(FSL_cntrl), 
        .FSL_write(FSL_write),
	   .rdy_out(rdy_out),
	   .done(done),
	   .dataA(dataA),
	   .dataB(dataB),
	   .mode(mode),
	   .result(result),
	   .size(size),
	   .stage(stage),
	   .data_out(data_out)
        );

always #5 clk = ~clk;

task put_data;
	output [15:0] FSL_data;
	output FSL_exists;
	input  [15:0] data;
	begin
		FSL_data = data;
		FSL_exists = 1'b1;
	end
endtask

always @(FSL_top_read) 	 FSL_top_exists = 0;
always @(FSL_bottom_read) FSL_bottom_exists = 0;

initial begin
	rst = 1;
	clk = 0;
	FSL_top_exists = 0;
	FSL_bottom_exists = 0;
	FSL_full = 0;
	$display("STARTING SYSTEM");

	#50
	rst = 0;
	#100

	fork: two
	begin
		#50
		put_data (FSL_top_data, FSL_top_exists, 3'b010);

		for (i = 0; i < 50; i = i + 1)
		begin
			#64
			put_data (FSL_top_data, FSL_top_exists, i);
		end
	end

	begin
		#100
		put_data (FSL_bottom_data, FSL_bottom_exists, 3'b001);

		for (i2 = 0; i2 < 50; i2 = i2 + 1)
		begin
			#64
			put_data (FSL_bottom_data, FSL_bottom_exists, i2);
		end
	end
	join

end


endmodule

