module zbtio(emcchipselect, emcoen, emc2zbt_data, zbt2emc_data, tribuff_enable,
	     bank0data_I, bank0data_O, bank0data_T,
	     bank1data_I, bank1data_O, bank1data_T,
	     bank2data_I, bank2data_O, bank2data_T,
	     bank3data_I, bank3data_O, bank3data_T,
	     bank4data_I, bank4data_O, bank4data_T,
	     bank0ce, bank1ce, bank2ce, bank3ce, bank4ce,
	     bank0oen, bank1oen, bank2oen, bank3oen, bank4oen
	     );

   parameter NUMBANKS = 5;
   parameter DATAWIDTH = 32;
   
   input [0:NUMBANKS - 1] emcchipselect;
   input [0:NUMBANKS - 1] emcoen;
   input [0:DATAWIDTH - 1] emc2zbt_data;
   output [0:DATAWIDTH - 1] zbt2emc_data;
   input [0:DATAWIDTH - 1]  tribuff_enable;

   input [0:DATAWIDTH - 1]  bank0data_I;
   input [0:DATAWIDTH - 1]  bank1data_I;
   input [0:DATAWIDTH - 1]  bank2data_I;
   input [0:DATAWIDTH - 1]  bank3data_I;
   input [0:DATAWIDTH - 1]  bank4data_I;
   output [0:DATAWIDTH - 1]  bank0data_O;
   output [0:DATAWIDTH - 1]  bank1data_O;
   output [0:DATAWIDTH - 1]  bank2data_O;
   output [0:DATAWIDTH - 1]  bank3data_O;
   output [0:DATAWIDTH - 1]  bank4data_O;
   output [0:DATAWIDTH - 1]  bank0data_T;
   output [0:DATAWIDTH - 1]  bank1data_T;
   output [0:DATAWIDTH - 1]  bank2data_T;
   output [0:DATAWIDTH - 1]  bank3data_T;
   output [0:DATAWIDTH - 1]  bank4data_T;

   output 		    bank0ce;
   output 		    bank1ce;
   output 		    bank2ce;
   output 		    bank3ce;
   output 		    bank4ce;

   output 		    bank0oen;
   output 		    bank1oen;
   output 		    bank2oen;
   output 		    bank3oen;
   output 		    bank4oen;

   integer 		    i;

   reg [0:DATAWIDTH - 1]    zbt2emc_data;
   
   assign 		    bank0ce = emcchipselect[0];
   assign 		    bank1ce = emcchipselect[1];
   assign 		    bank2ce = emcchipselect[2];
   assign 		    bank3ce = emcchipselect[3];
   assign 		    bank4ce = emcchipselect[4];

   assign 		    bank0oen = emcoen[0];
   assign 		    bank1oen = emcoen[1];
   assign 		    bank2oen = emcoen[2];
   assign 		    bank3oen = emcoen[3];
   assign 		    bank4oen = emcoen[4];

   //Mux
   always @ (emcchipselect or bank0data_I or bank1data_I or bank3data_I or bank4data_I)
     begin
	for( i = 0; i < DATAWIDTH; i = i + 1)
	  begin
	     case(emcchipselect)
	       5'b01111:
		 zbt2emc_data[i] = bank0data_I[i];
	       5'b10111:
		 zbt2emc_data[i] = bank1data_I[i];
	       5'b11011:
		 zbt2emc_data[i] = bank2data_I[i];
	       5'b11101:
		 zbt2emc_data[i] = bank3data_I[i];
	       5'b11110:
		 zbt2emc_data[i] = bank4data_I[i];
	     endcase // case(emcchipselect)
	  end // for ( i = 0; i < DATAWIDTH; i = i + 1)
     end // always @ (emcchipselect or bank0data_I or bank1data_I or bank3data_I or bank4data_I)

   assign bank0data_O = emc2zbt_data;
   assign bank1data_O = emc2zbt_data;
   assign bank2data_O = emc2zbt_data;
   assign bank3data_O = emc2zbt_data;
   assign bank4data_O = emc2zbt_data;
   
   assign bank0data_T = tribuff_enable;
   assign bank1data_T = tribuff_enable;
   assign bank2data_T = tribuff_enable;
   assign bank3data_T = tribuff_enable;
   assign bank4data_T = tribuff_enable;
   
endmodule // zbtdataio
